//
//  Ball.h
//  NXTPong
//  http://lenkaspace.net/lab/legoMindstorms/nxtPong
//
//  Handles behaviour and rendering of the ball

#define BALL_WIDTH 2
#define BALL_SPEED 2


struct Ball {
	int x;
	int y;
	int dx;
	int dy;
	bool wasMissedByPlayer1;
	bool wasMissedByPlayer2;
};

Ball ball;

/**
 * Main init function
 */
void ball_init() {
	ball.x = SCREEN_WIDTH/2;
	ball.y = SCREEN_HEIGHT/2;
	ball.dx = Random(10) % 2 * 2 - 1; //-1 or 1
	ball.dy = Random(10) % 2 * 2 - 1;
	ball.wasMissedByPlayer1 = false;
	ball.wasMissedByPlayer2 = false;
}

/**
 * Main update function
 */
void ball_update() {
	ball.x += ball.dx*BALL_SPEED;
    ball.y += ball.dy*BALL_SPEED;
    if (ball.y <= BALL_WIDTH || ball.y >= SCREEN_HEIGHT - BALL_WIDTH) {
        ball.dy *= -1;
	}
	
	if (ball.x <= paddle1.x + PADDLE_WIDTH && ball.y > paddle1.y - PADDLE_HEIGHT/2 && ball.y < paddle1.y + PADDLE_HEIGHT/2 ) {
		//-- collision with paddle1:
		ball.dx *= -1;
    } else if (ball.x >= paddle2.x && ball.y > paddle2.y - PADDLE_HEIGHT/2 && ball.y < paddle2.y + PADDLE_HEIGHT/2 ) {
        //-- collision with paddle2:
		ball.dx *= -1;
	}
	
	//-- out of screen?
	if (ball.x < 0) {
		ball.wasMissedByPlayer1 = true;
	} else if (ball.x > SCREEN_WIDTH) {
		ball.wasMissedByPlayer2 = true;
	}
}

/**
 * Main render function
 */
void ball_render() {
	RectOut(ball.x-BALL_WIDTH/2, ball.y-BALL_WIDTH/2, BALL_WIDTH, BALL_WIDTH, DRAW_OPT_NORMAL+DRAW_OPT_FILL_SHAPE); 
}
