//
//  Paddles.h
//  NXTPong
//  http://lenkaspace.net/lab/legoMindstorms/nxtPong
//
//  Handles behaviour and rendering of paddles


#define PADDLE_WIDTH 2
#define PADDLE_HEIGHT 15

struct Paddle {
	int x;
	int y;
};

Paddle paddle1;
Paddle paddle2;

/**
 * Main init function
 */
void paddles_init() {
	paddle1.x = 0;
	paddle1.y = SCREEN_HEIGHT/2;
	paddle2.x = SCREEN_WIDTH-PADDLE_WIDTH-1;
	paddle2.y = SCREEN_HEIGHT/2;
}

/**
 * Main update function
 */
void paddles_update() {
	int movementSpan = SCREEN_HEIGHT - PADDLE_HEIGHT - 1;
	paddle1.y = PADDLE_HEIGHT/2 + (movementSpan*(sensorHandler_getSensor1Value()));
    paddle2.y = PADDLE_HEIGHT/2 + (movementSpan*(1-sensorHandler_getSensor2Value()));
}


/**
 * Main render function
 */
void paddles_render() {
	//-- render player 1
	RectOut(paddle1.x, paddle1.y-PADDLE_HEIGHT/2, PADDLE_WIDTH, PADDLE_HEIGHT, DRAW_OPT_NORMAL+DRAW_OPT_FILL_SHAPE); 
	//-- render player 2
	RectOut(paddle2.x, paddle2.y-PADDLE_HEIGHT/2, PADDLE_WIDTH, PADDLE_HEIGHT, DRAW_OPT_NORMAL+DRAW_OPT_FILL_SHAPE); 
}