//
//  SensorHandler.h
//  NXTPong
//  http://lenkaspace.net/lab/legoMindstorms/nxtPong
//
//  Initialises and handles updates of sensors
//

#define SENSOR_MIN_DISTANCE 8
#define SENSOR_MAX_DISTANCE 13



float sensor1Value;
float sensor2Value;

/**
 * Initialise all sensors
 */
void sensorHandler_init() {
    //-- nxc sensor init
	SetSensorLowspeed(S1);
    SetSensorLowspeed(S4);	
	sensor1Value = 0.5;
	sensor2Value = 0.5;
    
}

/**
 * Main update function. Needs to be called every update loop so that a sensor value can be read
 */
void sensorHandler_update() {
	//-- sensor player 1
    float sensorScopedValue = 0;
    int sensorActualValue = 0;
    int sensorValueSpan = SENSOR_MAX_DISTANCE - SENSOR_MIN_DISTANCE;
    sensorActualValue = SensorUS(S1);
    ClearScreen();
    NumOut(0,0,sensorActualValue);
    if (sensorActualValue > SENSOR_MAX_DISTANCE) {
        sensorActualValue = SENSOR_MAX_DISTANCE;
    }
    if (sensorActualValue < SENSOR_MIN_DISTANCE) {
        sensorActualValue = SENSOR_MIN_DISTANCE;
    }
    sensorScopedValue = (sensorActualValue - SENSOR_MIN_DISTANCE)/sensorValueSpan;
    NumOut(0,50,sensorScopedValue);
    if (sensor1Value < 0) {
        sensor1Value = sensorScopedValue;
    } else {
        sensor1Value += (1.0/2.5)*(-sensor1Value + sensorScopedValue);
    }
	
	//-- sensor player 2
	sensorScopedValue = 0;
	sensorActualValue = 0;
    sensorActualValue = SensorUS(S4);
    if (sensorActualValue > SENSOR_MAX_DISTANCE) {
        sensorActualValue = SENSOR_MAX_DISTANCE;
    }
    if (sensorActualValue < SENSOR_MIN_DISTANCE) {
        sensorActualValue = SENSOR_MIN_DISTANCE;
    }
    sensorScopedValue = (sensorActualValue - SENSOR_MIN_DISTANCE)/sensorValueSpan;
    
    if (sensor2Value < 0) {
        sensor2Value = sensorScopedValue;
    } else {
        sensor2Value += (1.0/2.5)*(-sensor2Value + sensorScopedValue);
    }
	
}

/**
 * Get value of sensor for Player 1.
 * Returns float between 0 and 1
 */
float sensorHandler_getSensor1Value() {
	return sensor1Value;
}

/**
 * Get value of sensor for Player 2.
 * Returns float between 0 and 1
 */
float sensorHandler_getSensor2Value() {
	return sensor2Value;
}
